Index: branches/shared_lib/src/Makefile.am
===================================================================
--- branches/shared_lib/src/Makefile.am	(revision 7263)
+++ branches/shared_lib/src/Makefile.am	(revision 7264)
@@ -2,5 +2,4 @@
 include $(MAINSRCDIR)/defs/include_paths.am
 
-include world_entities/WorldEntities.am
 include story_entities/Makefile.am
 
@@ -12,6 +11,7 @@
 bin_PROGRAMS = orxonox
 
-orxonox_CPPFLAGS = -DIS_ORXONOX
-orxonox_LDFLAGS = -u global_ModelParticles_Factory
+orxonox_CPPFLAGS = -DIS_ORXONOX -DPKG_LIBDIR="\"$(pkglibdir)\""
+orxonox_LDFLAGS = --export-dynamic
+##-ldl -rdynamic
 
 orxonox_DEPENDENCIES = \
@@ -27,5 +27,4 @@
 
 orxonox_SOURCES = \
-		$(WorldEntities_SOURCES_) \
 		$(StoryEntities_SOURCES_) \
 		orxonox.cc \
Index: branches/shared_lib/src/defs/debug.h
===================================================================
--- branches/shared_lib/src/defs/debug.h	(revision 7263)
+++ branches/shared_lib/src/defs/debug.h	(revision 7264)
@@ -68,5 +68,5 @@
 
   // LOADING
-  #define DEBUG_MODULE_LOAD                  2
+  #define DEBUG_MODULE_LOADING               2
   #define DEBUG_MODULE_IMPORTER              2
 
Index: branches/shared_lib/src/lib/BuildLibs.am
===================================================================
--- branches/shared_lib/src/lib/BuildLibs.am	(revision 7263)
+++ branches/shared_lib/src/lib/BuildLibs.am	(revision 7264)
@@ -4,7 +4,6 @@
                 $(LIB_PREFIX)/gui/gtk_gui/libORXgui.a \
                 $(LIB_PREFIX)/gui/gl_gui/libORXglgui.a \
-                $(LIB_PREFIX)/graphics/importer/libORXimporter.a \
+                $(LIB_PREFIX)/graphics/importer/libORXimporter.la \
                 $(LIB_PREFIX)/graphics/libORXgraphics.a \
-                $(LIB_PREFIX)/graphics/importer/libtc.a \
                 $(LIB_PREFIX)/sound/libORXsound.a \
                 $(LIB_PREFIX)/event/libORXevent.a \
Index: branches/shared_lib/src/lib/graphics/Makefile.am
===================================================================
--- branches/shared_lib/src/lib/graphics/Makefile.am	(revision 7263)
+++ branches/shared_lib/src/lib/graphics/Makefile.am	(revision 7264)
@@ -4,37 +4,39 @@
 noinst_LIBRARIES = libORXgraphics.a
 
-libORXgraphics_a_SOURCES = graphics_engine.cc \
-			   light.cc \
-			   shader.cc \
-			   \
-			   render2D/render_2d.cc \
-			   render2D/element_2d.cc \
-			   render2D/billboard.cc \
-			   \
-			   text_engine/text_engine.cc \
-			   text_engine/text.cc \
-			   text_engine/font.cc \
-			   \
-			   effects/graphics_effect.cc \
-			   effects/fog_effect.cc \
-			   effects/lense_flare.cc
+libORXgraphics_a_SOURCES = \
+		graphics_engine.cc \
+		light.cc \
+		shader.cc \
+		\
+		render2D/render_2d.cc \
+		render2D/element_2d.cc \
+		render2D/billboard.cc \
+		\
+		text_engine/text_engine.cc \
+		text_engine/text.cc \
+		text_engine/font.cc \
+		\
+		effects/graphics_effect.cc \
+		effects/fog_effect.cc \
+		effects/lense_flare.cc
 
 
-noinst_HEADERS = graphics_engine.h \
-		 light.h \
-		 shader.h \
-		 \
-		 render2D/render_2d.h \
-		 render2D/element_2d.h \
-		 render2D/billboard.h \
-		 \
-		 text_engine/text_engine.h \
-		 text_engine/text.h \
-		 text_engine/font.h \
-		 text_engine/default_font.xpm \
-		 \
-		 effects/graphics_effect.h \
-		 effects/fog_effect.h \
-		 effects/lense_flare.h
+noinst_HEADERS = \
+		graphics_engine.h \
+		light.h \
+		shader.h \
+		\
+		render2D/render_2d.h \
+		render2D/element_2d.h \
+		render2D/billboard.h \
+		\
+		text_engine/text_engine.h \
+		text_engine/text.h \
+		text_engine/font.h \
+		text_engine/default_font.xpm \
+		\
+		effects/graphics_effect.h \
+		effects/fog_effect.h \
+		effects/lense_flare.h
 
 
Index: branches/shared_lib/src/lib/graphics/importer/Makefile.am
===================================================================
--- branches/shared_lib/src/lib/graphics/importer/Makefile.am	(revision 7263)
+++ branches/shared_lib/src/lib/graphics/importer/Makefile.am	(revision 7264)
@@ -2,37 +2,37 @@
 include $(MAINSRCDIR)/defs/include_paths.am
 
-noinst_LIBRARIES = libORXimporter.a libtc.a
+pkglib_LTLIBRARIES = libORXimporter.la
 
-libORXimporter_a_SOURCES = model.cc \
-                           vertex_array_model.cc \
-                           grid.cc \
-                           static_model.cc \
-                           objModel.cc \
-                           primitive_model.cc \
-                           md2Model.cc \
-                           material.cc \
-                           texture.cc \
-                           texture_sequence.cc \
-                           height_map.cc \
-                           media_container.cc \
-                           movie_player.cc
+libORXimporter_la_SOURCES = \
+		model.cc \
+		tc.cc \
+		vertex_array_model.cc \
+		grid.cc \
+		static_model.cc \
+		objModel.cc \
+		primitive_model.cc \
+		md2Model.cc \
+		material.cc \
+		texture.cc \
+		texture_sequence.cc \
+		height_map.cc \
+		media_container.cc \
+		movie_player.cc
 
-libtc_a_SOURCES  = tc.cc
-
-
-noinst_HEADERS = model.h \
-		 tc.h \
-                 vertex_array_model.h \
-                 grid.h \
-                 static_model.h \
-                 objModel.h \
-                 primitive_model.h \
-                 md2Model.h \
-                 material.h \
-                 texture.h \
-                 texture_sequence.h \
-                 height_map.h \
-                 anorms.h \
-                 anormtab.h \
-                 media_container.h \
-                 movie_player.h
+noinst_HEADERS = \
+		model.h \
+		tc.h \
+		vertex_array_model.h \
+		grid.h \
+		static_model.h \
+		objModel.h \
+		primitive_model.h \
+		md2Model.h \
+		material.h \
+		texture.h \
+		texture_sequence.h \
+		height_map.h \
+		anorms.h \
+		anormtab.h \
+		media_container.h \
+		movie_player.h
Index: branches/shared_lib/src/lib/util/loading/dynamic_loader.cc
===================================================================
--- branches/shared_lib/src/lib/util/loading/dynamic_loader.cc	(revision 7263)
+++ branches/shared_lib/src/lib/util/loading/dynamic_loader.cc	(revision 7264)
@@ -17,11 +17,7 @@
 
 #include "dynamic_loader.h"
-
-
-#include <dlfcn.h>
-
+#include "resource_manager.h"
 
 using namespace std;
-
 
 /**
@@ -30,5 +26,4 @@
 */
 DynamicLoader::DynamicLoader (const std::string& libName)
-    : Factory(NULL, CL_NULL)
 {
   this->setClassID(CL_DYNAMIC_LOADER, "DynamicLoader");
@@ -40,4 +35,18 @@
 }
 
+/**
+ * @brief initializes the Dynamic Library loader
+ * @returns true on succes, false otherwise
+ */
+bool DynamicLoader::initialize()
+{
+  if (lt_dlinit () != 0)
+  {
+    PRINTF(1)("Initializing LT_DL_LIB: %s\n", lt_dlerror());
+    return false;
+  }
+  else
+    return true;
+}
 
 /**
@@ -48,5 +57,5 @@
   // delete what has to be deleted here
   if (this->handle != NULL)
-    dlclose(this->handle);
+    lt_dlclose(this->handle);
 }
 
@@ -54,27 +63,61 @@
 bool DynamicLoader::loadDynamicLib(const std::string& libName)
 {
-  this->handle = dlopen(&libName[0], RTLD_NOW);
+  DynamicLoader::initialize();
+
+  this->handle = lt_dlopen(&libName[0]);
   if(this->handle == NULL)
   {
     return false;
   }
-  void *mkr = dlsym( this->handle, "maker");
 }
 
 bool DynamicLoader::loadDyLib(const std::string& libName)
 {
+  DynamicLoader::initialize();
+
   void* handle;
-  handle = dlopen(&libName[0], RTLD_NOW);
+  handle = lt_dlopen(libName.c_str());
   if(handle == NULL)
   {
-    PRINTF(0)("unable to load %s\n", &libName[0]);
+    PRINTF(1)("unable to load %s: %s\n", libName.c_str(), lt_dlerror());
+
     return false;
   }
-//  void *mkr = dlsym("maker");
+
+}
+
+void DynamicLoader::addSearchDir(const std::string& searchDir)
+{
+  DynamicLoader::initialize();
+
+  lt_dladdsearchdir(searchDir.c_str());
+}
+
+/**
+ * @param relSearchDir: the Relative directory to add to searchPath of lt_dl
+ * @returns true if the Path was Valid, false otherwise
+ */
+bool DynamicLoader::addSearchDirRelative(const std::string& relSearchDir)
+{
+  std::string absSearchDir = ResourceManager::getAbsDir(relSearchDir);
+  if (ResourceManager::isDir(absSearchDir))
+  {
+    DynamicLoader::addSearchDir(absSearchDir);
+    return true;
+  }
+  else
+  {
+    return false;
+  }
+}
+
+bool DynamicLoader::addSearchDirInLibDir(const std::string& relSearchDir)
+{
 
 }
 
 
-BaseObject* DynamicLoader::fabricateObject(const TiXmlElement* root) const
+const char* DynamicLoader::getSearchDir()
 {
+  return lt_dlgetsearchpath();
 }
Index: branches/shared_lib/src/lib/util/loading/dynamic_loader.h
===================================================================
--- branches/shared_lib/src/lib/util/loading/dynamic_loader.h	(revision 7263)
+++ branches/shared_lib/src/lib/util/loading/dynamic_loader.h	(revision 7264)
@@ -8,14 +8,12 @@
 
 #include "util/loading/factory.h"
+#include <ltdl.h>
 
 #include <string>
-
-#define DYNAMIC_LINKAGE_FACTORY(CLASS_NAME, CLASS_ID) \
-          void* DynamicCreator(const TiXmlElement* root) { return new CLASS_NAME(root); };
 
 // FORWARD DECLARATION
 
 //! A class for ...
-class DynamicLoader : public Factory
+class DynamicLoader : public BaseObject
 {
 
@@ -25,11 +23,19 @@
 
   bool loadDynamicLib(const std::string& libName);
-  virtual BaseObject* fabricateObject(const TiXmlElement* root = NULL) const;
 
   static bool loadDyLib(const std::string& libName);
 
+  static void addSearchDir(const std::string& searchDir);
+  static bool addSearchDirRelative(const std::string& relSearchDir);
+  static bool addSearchDirInLibDir(const std::string& relSearchDir);
+  static const char* getSearchDir();
+
+  static void unload();
+private:
+  // will be done automatically when using the this Engine.
+  static bool initialize();
 
 private:
-  void*      handle;
+  lt_dlhandle      handle;
 };
 
Index: branches/shared_lib/src/lib/util/loading/resource_manager.cc
===================================================================
--- branches/shared_lib/src/lib/util/loading/resource_manager.cc	(revision 7263)
+++ branches/shared_lib/src/lib/util/loading/resource_manager.cc	(revision 7264)
@@ -881,4 +881,6 @@
 
 
+
+
 /**
  * @param fileName the Name of the File to check
@@ -921,5 +923,4 @@
   return ResourceManager::getInstance()->_cwd;
 }
-
 
 /**
Index: branches/shared_lib/src/orxonox.cc
===================================================================
--- branches/shared_lib/src/orxonox.cc	(revision 7263)
+++ branches/shared_lib/src/orxonox.cc	(revision 7264)
@@ -54,4 +54,5 @@
 
 #include "util/loading/load_param_description.h"
+#include "util/loading/dynamic_loader.h"
 
 #include "network_manager.h"
@@ -292,5 +293,6 @@
     NetworkManager::getInstance()->establishConnection(this->serverName, port);
   }
-  else if( this->port > 0) {    // we are a server
+  else if( this->port > 0)
+  {    // we are a server
     State::setOnline(true);
     NetworkManager::getInstance()->createServer(port);
@@ -300,5 +302,4 @@
 
 #include "util/loading/dynamic_loader.h"
-
 /**
  * initializes and loads resource files
@@ -340,5 +341,21 @@
   ResourceManager::getInstance()->addImageDir(imageDir);
 
-  DynamicLoader::loadDyLib("libtest.so");
+  if (!DynamicLoader::addSearchDirRelative("./world_entities"))
+    if (!DynamicLoader::addSearchDirRelative("./src/world_entities"))
+      DynamicLoader::addSearchDir(PKG_LIBDIR);
+
+  /// FIXME make this more modular (search for himself for all the libraries
+  printf("%s\n", DynamicLoader::getSearchDir());
+  DynamicLoader::loadDyLib("libORXplayables.la");
+  DynamicLoader::loadDyLib("libORXweapons.la");
+  DynamicLoader::loadDyLib("libORXprojectiles.la");
+  DynamicLoader::loadDyLib("libORXpower_ups.la");
+
+  DynamicLoader::loadDyLib("libORXenvironmentals.la");
+
+  DynamicLoader::loadDyLib("libORXnpcs");
+
+  DynamicLoader::loadDyLib("libORXmisc_entities");
+  printf("%s\n", DynamicLoader::getSearchDir());
 
   // start the collision detection engine
@@ -417,9 +434,9 @@
 {
   CmdLinePrefsReader prefs;
-  
+
   IniFilePrefsReader ini(ResourceManager::homeDirCheck(DEFAULT_CONFIG_FILE));
-  
+
   prefs.parse(argc, argv);
-  
+
   if ( Preferences::getInstance()->getString("misc", "showLicenseAndExit", "") == "1" )
   {
@@ -427,5 +444,5 @@
     return 0;
   }
-  
+
   if( Preferences::getInstance()->getString("game", "showGui", "") == "1" )
     showGui = true;
@@ -433,5 +450,5 @@
            Preferences::getInstance()->getString( "game", "gameType", "" ) == "multiplayer_client" )
     return startNetworkOrxonox(argc, argv);
-  
+
   return startOrxonox(argc, argv, "", -1);
   return 0;
@@ -449,10 +466,10 @@
 
   std::string gameType = Preferences::getInstance()->getString( "game", "gameType", "" );
-  
+
   if ( gameType == "multiplayer_client" )
   {
     int port = Preferences::getInstance()->getInt( "game", "port", DEFAULT_ORXONOX_PORT );
     std::string host = Preferences::getInstance()->getString( "game", "host", "" );
-    
+
     if ( host == "" )
     {
@@ -460,7 +477,7 @@
       return 1;
     }
-    
+
     printf("Starting Orxonox as client: connecting to %s, on port %i\n", host.c_str(), port);
-    
+
     startOrxonox(argc, argv, host.c_str(), port);
   }
@@ -468,7 +485,7 @@
   {
     int port = Preferences::getInstance()->getInt( "game", "port", DEFAULT_ORXONOX_PORT );
-    
+
     printf("Starting Orxonox as server: listening on port %i\n", port);
-    
+
     startOrxonox(argc, argv, "", port);
   }
Index: branches/shared_lib/src/subprojects/collision_detection/Makefile.am
===================================================================
--- branches/shared_lib/src/subprojects/collision_detection/Makefile.am	(revision 7263)
+++ branches/shared_lib/src/subprojects/collision_detection/Makefile.am	(revision 7264)
@@ -4,5 +4,4 @@
 LIB_PREFIX=$(MAINSRCDIR)/lib
 include $(MAINSRCDIR)/lib/BuildLibs.am
-
 
 bin_PROGRAMS = collision
@@ -21,5 +20,4 @@
 		$(GTK2_LIBS) $(GTHREAD_LIBS) $(CURL_LIBS)
 
-
 collision_CPPFLAGS =  \
 		-DGUI_MODULE   \
Index: branches/shared_lib/src/util/Makefile.am
===================================================================
--- branches/shared_lib/src/util/Makefile.am	(revision 7263)
+++ branches/shared_lib/src/util/Makefile.am	(revision 7264)
@@ -3,4 +3,7 @@
 
 noinst_LIBRARIES = libORXutils.a
+
+INCLUDES = $(LTDLINCL)
+
 
 libORXutils_a_SOURCES = fast_factory.cc \
@@ -20,4 +23,5 @@
 			track/track_node.cc
 
+
 noinst_HEADERS =        fast_factory.h \
 			object_manager.h \
Index: branches/shared_lib/src/world_entities/Makefile.am
===================================================================
--- branches/shared_lib/src/world_entities/Makefile.am	(revision 7263)
+++ branches/shared_lib/src/world_entities/Makefile.am	(revision 7264)
@@ -1,7 +1,10 @@
 MAINSRCDIR=..
 include $(MAINSRCDIR)/defs/include_paths.am
-include WorldEntities.am
 
 noinst_LIBRARIES = libORXwe.a
+
+## TODO ::
+WRONG_SORTED_SOURCES_ = space_ships/space_ship.cc
+
 
 ## THESE ARE THE BASE CLASSES OF ALL WORLD_ENTITIES
@@ -27,7 +30,80 @@
 		spawning_point.cc \
 		\
+		skybox.cc \
+		terrain.cc \
 		\
-		effects/explosion.cc
+		elements/image_entity.cc \
+		elements/text_element.cc \
+		\
+		effects/explosion.cc \
+		\
+		$(WRONG_SORTED_SOURCES_)
 
+LDFLAGS = --export-dynamic -module
+
+pkglib_LTLIBRARIES = \
+		libORXplayables.la \
+		libORXweapons.la \
+		libORXprojectiles.la \
+		libORXpower_ups.la \
+		\
+		libORXenvironmentals.la \
+		\
+		libORXnpcs.la \
+		\
+		libORXmisc_entities.la
+
+
+libORXplayables_la_SOURCES = \
+		space_ships/helicopter.cc \
+		space_ships/hover.cc \
+		space_ships/turbine_hover.cc \
+		creatures/md2_creature.cc
+
+libORXweapons_la_SOURCES = \
+		weapons/turret.cc \
+		weapons/aiming_turret.cc \
+		weapons/targeting_turret.cc \
+		weapons/cannon.cc \
+		weapons/hyperblaster.cc \
+		weapons/aim.cc\
+		weapons/test_gun.cc
+
+libORXprojectiles_la_SOURCES = \
+		projectiles/bomb.cc \
+		projectiles/laser.cc \
+		projectiles/test_bullet.cc \
+		projectiles/rocket.cc \
+		projectiles/guided_missile.cc \
+		projectiles/hyperblast.cc
+
+libORXpower_ups_la_SOURCES = \
+		power_ups/turret_power_up.cc \
+		power_ups/laser_power_up.cc
+
+
+libORXnpcs_la_SOURCES = \
+		npcs/ground_turret.cc \
+		npcs/npc_test.cc \
+		npcs/npc_test1.cc
+
+libORXenvironmentals_la_SOURCES = \
+		environment.cc \
+		skysphere.cc \
+		satellite.cc \
+		character_attributes.cc \
+		test_entity.cc \
+		planet.cc \
+		environments/water.cc \
+		environments/model_entity.cc \
+		environments/building.cc \
+		\
+		movie_entity.cc \
+		recorder.cc
+
+
+libORXmisc_entities_la_SOURCES = \
+		\
+		effects/lightning_bolt.cc
 
 
@@ -57,6 +133,50 @@
 		effects/explosion.h \
 		\
-		$(WorldEntities_HEADERS_)
+		\
+		\
+		npcs/npc_test.h \
+		npcs/npc_test1.h \
+		npcs/ground_turret.h \
+		environment.h \
+		skysphere.h \
+		skybox.h \
+		terrain.h \
+		satellite.h \
+		movie_entity.h \
+		recorder.h \
+		character_attributes.h \
+		test_entity.h \
+		planet.h \
+		\
+		weapons/test_gun.h \
+		weapons/cannon.h \
+		weapons/hyperblaster.h \
+		weapons/turret.h \
+		weapons/aiming_turret.h \
+		weapons/targeting_turret.h \
+		weapons/aim.h \
+		\
+		projectiles/bomb.h \
+		projectiles/laser.h \
+		projectiles/test_bullet.h \
+		projectiles/rocket.h \
+		projectiles/guided_missile.h \
+		projectiles/hyperblast.h \
+		\
+		power_ups/turret_power_up.h \
+		power_ups/laser_power_up.h \
+		\
+		space_ships/space_ship.h \
+		space_ships/helicopter.h \
+		space_ships/hover.h \
+		space_ships/turbine_hover.h \
+		creatures/md2_creature.h \
+		\
+		environments/water.h \
+		environments/model_entity.h \
+		environments/building.h \
+		elements/image_entity.h \
+		elements/text_element.h \
+		\
+		effects/lightning_bolt.h
 
-
-EXTRA_DIST = WorldEntities.am
Index: branches/shared_lib/src/world_entities/WorldEntities.am
===================================================================
--- branches/shared_lib/src/world_entities/WorldEntities.am	(revision 7263)
+++ branches/shared_lib/src/world_entities/WorldEntities.am	(revision 7264)
@@ -3,5 +3,4 @@
 		world_entities/npcs/npc_test1.cc \
 		world_entities/npcs/npc_test.cc \
-		world_entities/npcs/ground_turret.cc \
 		\
 		world_entities/environment.cc \
@@ -51,49 +50,2 @@
 
 
-WorldEntities_HEADERS_ = \
-		npcs/npc_test.h \
-		npcs/npc_test1.h \
-		npcs/ground_turret.h \
-		environment.h \
-		skysphere.h \
-		skybox.h \
-		terrain.h \
-		satellite.h \
-		movie_entity.h \
-		recorder.h \
-		character_attributes.h \
-		test_entity.h \
-		planet.h \
-		\
-		weapons/test_gun.h \
-		weapons/cannon.h \
-		weapons/hyperblaster.h \
-		weapons/turret.h \
-		weapons/aiming_turret.h \
-		weapons/targeting_turret.h \
-		weapons/aim.h \
-		\
-		projectiles/bomb.h \
-		projectiles/laser.h \
-		projectiles/test_bullet.h \
-		projectiles/rocket.h \
-		projectiles/guided_missile.h \
-		projectiles/hyperblast.h \
-		\
-		power_ups/turret_power_up.h \
-		power_ups/laser_power_up.h \
-		\
-		space_ships/space_ship.h \
-		space_ships/helicopter.h \
-		space_ships/hover.h \
-		space_ships/turbine_hover.h \
-		creatures/md2_creature.h \
-		\
-		environments/water.h \
-		environments/model_entity.h \
-		environments/building.h \
-		\
-		elements/image_entity.h \
-		elements/text_element.h \
-		\
-		effects/lightning_bolt.h
Index: branches/shared_lib/src/world_entities/space_ships/helicopter.cc
===================================================================
--- branches/shared_lib/src/world_entities/space_ships/helicopter.cc	(revision 7263)
+++ branches/shared_lib/src/world_entities/space_ships/helicopter.cc	(revision 7264)
@@ -20,7 +20,4 @@
 
 #include "weapons/weapon_manager.h"
-#include "weapons/test_gun.h"
-#include "weapons/turret.h"
-#include "weapons/cannon.h"
 
 #include "util/loading/factory.h"
@@ -82,14 +79,14 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
+//  Weapon* wpRight = new TestGun(0);
+//  wpRight->setName("testGun Right");
+//  Weapon* wpLeft = new TestGun(1);
+//  wpLeft->setName("testGun Left");
   Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
 
   cannon->setName("BFG");
 
-  this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1 ,1);
+//  this->addWeapon(wpLeft, 1, 0);
+//  this->addWeapon(wpRight,1 ,1);
   this->addWeapon(cannon, 0, 6);
 
Index: branches/shared_lib/src/world_entities/space_ships/hover.cc
===================================================================
--- branches/shared_lib/src/world_entities/space_ships/hover.cc	(revision 7263)
+++ branches/shared_lib/src/world_entities/space_ships/hover.cc	(revision 7264)
@@ -20,7 +20,4 @@
 
 #include "weapons/weapon_manager.h"
-#include "weapons/test_gun.h"
-#include "weapons/turret.h"
-#include "weapons/cannon.h"
 
 #include "util/loading/factory.h"
@@ -74,15 +71,15 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
-
-  cannon->setName("BFG");
-
-  this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1 ,1);
-  this->addWeapon(cannon, 0, 2);
+//  Weapon* wpRight = new TestGun(0);
+//  wpRight->setName("testGun Right");
+//  Weapon* wpLeft = new TestGun(1);
+//  wpLeft->setName("testGun Left");
+//  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
+
+//  cannon->setName("BFG");
+
+//  this->addWeapon(wpLeft, 1, 0);
+//  this->addWeapon(wpRight,1 ,1);
+//  this->addWeapon(cannon, 0, 2);
 
   this->getWeaponManager()->changeWeaponConfig(1);
Index: branches/shared_lib/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/shared_lib/src/world_entities/space_ships/space_ship.cc	(revision 7263)
+++ branches/shared_lib/src/world_entities/space_ships/space_ship.cc	(revision 7264)
@@ -124,14 +124,14 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
+  //Weapon* wpRight = dynamic_cast<Weapon*>(Factory::fabricate("TestGun"));
+  //wpRight->setName("testGun Right");
+  //Weapon* wpLeft = dynamic_cast<Weapon*>(Factory::fabricate("TestGun"));
+  //wpLeft->setName("testGun Left");
   //Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
 
   //cannon->setName("BFG");
 
-  this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1 ,1);
+  //this->addWeapon(wpLeft, 1, 0);
+  //this->addWeapon(wpRight,1 ,1);
   //this->addWeapon(cannon, 0, 6);
 
Index: branches/shared_lib/src/world_entities/space_ships/turbine_hover.cc
===================================================================
--- branches/shared_lib/src/world_entities/space_ships/turbine_hover.cc	(revision 7263)
+++ branches/shared_lib/src/world_entities/space_ships/turbine_hover.cc	(revision 7264)
@@ -20,7 +20,4 @@
 
 #include "weapons/weapon_manager.h"
-#include "weapons/test_gun.h"
-#include "weapons/turret.h"
-#include "weapons/cannon.h"
 
 #include "util/loading/factory.h"
@@ -76,14 +73,14 @@
 
   //weapons:
-  Weapon* wpRight = new TestGun(0);
-  wpRight->setName("testGun Right");
-  Weapon* wpLeft = new TestGun(1);
-  wpLeft->setName("testGun Left");
+//  Weapon* wpRight = new TestGun(0);
+//  wpRight->setName("testGun Right");
+//  Weapon* wpLeft = new TestGun(1);
+//  wpLeft->setName("testGun Left");
   //Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
 
   //  cannon->setName("BFG");
 
-  this->addWeapon(wpLeft, 1, 0);
-  this->addWeapon(wpRight,1 ,1);
+//  this->addWeapon(wpLeft, 1, 0);
+//  this->addWeapon(wpRight,1 ,1);
   //this->addWeapon(cannon, 0, 2);
 