Index: /branches/shared_lib/configure.ac
===================================================================
--- /branches/shared_lib/configure.ac	(revision 7274)
+++ /branches/shared_lib/configure.ac	(revision 7275)
@@ -298,4 +298,5 @@
     MSBITFIELDS="-mms-bitfields"
     MWINDOWS="-mwindows"
+    LDFLAGS="$LDFLAGS "
 #--------#
 # MIN-GW #
@@ -392,4 +393,5 @@
  Linux="yes"
 
+ LDFLAGS="$LDFLAGS -rdynamic"
 ##CPPFLAGS="-I/usr/include $CPPFLAGS"
 ##LDFLAGS="-L/usr/lib $LDFLAGS"
@@ -637,4 +639,5 @@
                  src/lib/Makefile
                  src/lib/math/Makefile
+                 src/lib/util/Makefile
                  src/lib/graphics/Makefile
                  src/lib/graphics/importer/Makefile
Index: /branches/shared_lib/src/Makefile.am
===================================================================
--- /branches/shared_lib/src/Makefile.am	(revision 7274)
+++ /branches/shared_lib/src/Makefile.am	(revision 7275)
@@ -12,5 +12,5 @@
 
 orxonox_CPPFLAGS = -DIS_ORXONOX -DPKG_LIBDIR="\"$(pkglibdir)\""
-orxonox_LDFLAGS = --export-dynamic -ldl -rdynamic
+orxonox_LDFLAGS = --export-dynamic
 ##-ldl -rdynamic
 
Index: /branches/shared_lib/src/lib/BuildLibs.am
===================================================================
--- /branches/shared_lib/src/lib/BuildLibs.am	(revision 7274)
+++ /branches/shared_lib/src/lib/BuildLibs.am	(revision 7275)
@@ -4,7 +4,5 @@
                 $(LIB_PREFIX)/gui/gtk_gui/libORXgui.a \
                 $(LIB_PREFIX)/gui/gl_gui/libORXglgui.a \
-                $(LIB_PREFIX)/graphics/importer/libORXimporter.la \
                 $(LIB_PREFIX)/graphics/libORXgraphics.a \
-                $(LIB_PREFIX)/sound/libORXsound.a \
                 $(LIB_PREFIX)/event/libORXevent.a \
                 $(LIB_PREFIX)/physics/libORXphysics.a \
@@ -18,4 +16,7 @@
                 $(LIB_PREFIX)/parser/ini_parser/libIniParser.a \
                 $(LIB_PREFIX)/shell/libORXshell.a \
+                $(LIB_PREFIX)/util/libORXlibutil.a \
+                $(LIB_PREFIX)/sound/libORXsound.a \
+                $(LIB_PREFIX)/graphics/importer/libORXimporter.la \
                 $(LIB_PREFIX)/math/libORXmath.a \
                 $(LIB_PREFIX)/libORXlibs.a
Index: /branches/shared_lib/src/lib/Makefile.am
===================================================================
--- /branches/shared_lib/src/lib/Makefile.am	(revision 7274)
+++ /branches/shared_lib/src/lib/Makefile.am	(revision 7275)
@@ -10,18 +10,4 @@
 		coord/p_node.cc \
 		\
-		util/substring.cc \
-		util/color.cc \
-		util/helper_functions.cc \
-		util/multi_type.cc \
-		util/executor/executor.cc \
-		\
-		util/loading/resource_manager.cc \
-		util/loading/resource.cc \
-		util/loading/game_loader.cc \
-		util/loading/load_param.cc \
-		util/loading/load_param_description.cc \
-		util/loading/factory.cc \
-		util/loading/dynamic_loader.cc \
-		util/preferences.cc \
 		\
 		data/data_tank.cc
@@ -33,24 +19,4 @@
 		coord/p_node.h \
 		\
-		util/substring.h \
-		util/multi_type.h \
-		util/color.h \
-		util/helper_functions.h \
-		util/executor/executor.h \
-		util/executor/executor_specials.h \
-		util/executor/functor_list.h \
-		util/preferences.h \
-		\
-		util/loading/resource_manager.h \
-		util/loading/resource.h \
-		util/loading/game_loader.h \
-		util/loading/load_param.h \
-		util/loading/load_param_description.h \
-		util/loading/factory.h \
-		util/loading/dynamic_loader.h \
-		\
-		util/count_pointer.h \
-		util/list.h \
-		\
 		\
 		data/data_tank.h
@@ -59,4 +25,5 @@
 	. \
 	math \
+	util \
 	graphics \
 	sound \
Index: /branches/shared_lib/src/lib/util/Makefile.am
===================================================================
--- /branches/shared_lib/src/lib/util/Makefile.am	(revision 7275)
+++ /branches/shared_lib/src/lib/util/Makefile.am	(revision 7275)
@@ -0,0 +1,44 @@
+MAINSRCDIR=../..
+include $(MAINSRCDIR)/defs/include_paths.am
+
+noinst_LIBRARIES = libORXlibutil.a
+
+libORXlibutil_a_SOURCES = \
+		substring.cc \
+		color.cc \
+		helper_functions.cc \
+		multi_type.cc \
+		executor/executor.cc \
+		\
+		loading/resource_manager.cc \
+		loading/resource.cc \
+		loading/game_loader.cc \
+		loading/load_param.cc \
+		loading/load_param_description.cc \
+		loading/factory.cc \
+		loading/dynamic_loader.cc \
+		preferences.cc
+
+
+
+noinst_HEADERS = \
+		substring.h \
+		multi_type.h \
+		color.h \
+		helper_functions.h \
+		executor/executor.h \
+		executor/executor_specials.h \
+		executor/functor_list.h \
+		preferences.h \
+		\
+		loading/resource_manager.h \
+		loading/resource.h \
+		loading/game_loader.h \
+		loading/load_param.h \
+		loading/load_param_description.h \
+		loading/factory.h \
+		loading/dynamic_loader.h \
+		\
+		count_pointer.h \
+		list.h
+