Index: /code/branches/consolecommands3/data/levels/fps_test.oxw
===================================================================
--- /code/branches/consolecommands3/data/levels/fps_test.oxw	(revision 7275)
+++ /code/branches/consolecommands3/data/levels/fps_test.oxw	(revision 7276)
@@ -20,6 +20,6 @@
    skybox       = "Orxonox/skypanoramagen1"
    gravity      = "0,-1000,0"
-   negativeWorldRange = "(-100000, -100000, -100000)"
-   positiveWorldRange = "( 100000,  100000,  100000)"
+   negativeWorldRange = "-100000, -100000, -100000"
+   positiveWorldRange = " 100000,  100000,  100000"
    hasPhysics   = true
   >
Index: /code/branches/consolecommands3/data/levels/old/physicstest2.oxw
===================================================================
--- /code/branches/consolecommands3/data/levels/old/physicstest2.oxw	(revision 7275)
+++ /code/branches/consolecommands3/data/levels/old/physicstest2.oxw	(revision 7276)
@@ -13,6 +13,6 @@
    ambientlight = "0.5, 0.5, 0.5"
    skybox       = "Orxonox/Starbox"
-   negativeWorldRange = "(-100000, -100000, -100000)"
-   positiveWorldRange = "( 100000,  100000,  100000)"
+   negativeWorldRange = "-100000, -100000, -100000"
+   positiveWorldRange = " 100000,  100000,  100000"
    hasPhysics   = true
   >
Index: /code/branches/consolecommands3/data/levels/presentation_FS10.oxw
===================================================================
--- /code/branches/consolecommands3/data/levels/presentation_FS10.oxw	(revision 7275)
+++ /code/branches/consolecommands3/data/levels/presentation_FS10.oxw	(revision 7276)
@@ -20,6 +20,6 @@
    skybox       = "Orxonox/skypanoramagen1"
    gravity      = "0,-1000,0"
-   negativeWorldRange = "(-100000, -100000, -100000)"
-   positiveWorldRange = "( 100000,  100000,  100000)"
+   negativeWorldRange = "-100000, -100000, -100000"
+   positiveWorldRange = " 100000,  100000,  100000"
    hasPhysics   = true
   >
Index: /code/branches/consolecommands3/data/levels/presentation_FS10_ed.oxw
===================================================================
--- /code/branches/consolecommands3/data/levels/presentation_FS10_ed.oxw	(revision 7275)
+++ /code/branches/consolecommands3/data/levels/presentation_FS10_ed.oxw	(revision 7276)
@@ -20,6 +20,6 @@
    skybox       = "Orxonox/skypanoramagen1"
    gravity      = "0,-1000,0"
-   negativeWorldRange = "(-100000, -100000, -100000)"
-   positiveWorldRange = "( 100000,  100000,  100000)"
+   negativeWorldRange = "-100000, -100000, -100000"
+   positiveWorldRange = " 100000,  100000,  100000"
    hasPhysics   = true
   >
Index: /code/branches/consolecommands3/src/libraries/core/CommandLineParser.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/CommandLineParser.h	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/core/CommandLineParser.h	(revision 7276)
@@ -64,5 +64,5 @@
         Note the difference between "-" and "--"!
         Also, there is no restriction to the number of strings you add after --name.
-        So "--startVector (2, 4, 5)" is perfectly legal.
+        So "--startVector {2, 4, 5}" is perfectly legal.
 
         Retrieving an argument is possible with the getCommandLineArgument function of the
Index: /code/branches/consolecommands3/src/libraries/core/ConfigValueContainer.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/ConfigValueContainer.cc	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/core/ConfigValueContainer.cc	(revision 7276)
@@ -302,5 +302,5 @@
     bool ConfigValueContainer::callFunctionWithIndex(bool (ConfigValueContainer::* function) (unsigned int, const MultiType&), const std::string& input)
     {
-        SubString token(input, " ", SubString::WhiteSpaces, true, '\\', false, '"', false, '(', ')', false, '\0');
+        SubString token(input, " ", SubString::WhiteSpaces, true, '\\', false, '"', false, '\0', '\0', false, '\0');
         int index = -1;
         bool success = false;
Index: /code/branches/consolecommands3/src/libraries/core/GraphicsManager.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/GraphicsManager.cc	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/core/GraphicsManager.cc	(revision 7276)
@@ -293,5 +293,5 @@
         boost::filesystem::path folder(ogrePluginsDirectory_);
         // Do some SubString magic to get the comma separated list of plugins
-        SubString plugins(ogrePlugins_, ",", " ", false, '\\', false, '"', false, '(', ')', false, '\0');
+        SubString plugins(ogrePlugins_, ",", " ", false, '\\', false, '"', false, '{', '}', false, '\0');
         // Use backslash paths on Windows! file_string() already does that though.
         for (unsigned int i = 0; i < plugins.size(); ++i)
Index: /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.cc	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/core/command/ArgumentCompletionFunctions.cc	(revision 7276)
@@ -147,5 +147,5 @@
         ARGUMENT_COMPLETION_FUNCTION_IMPLEMENTATION_MULTI(hiddencommand)(const std::string& fragment)
         {
-            SubString tokens(fragment, " ", SubString::WhiteSpaces, false, '\\', true, '"', true, '(', ')', true, '\0');
+            SubString tokens(fragment, " ", SubString::WhiteSpaces, false, '\\', true, '"', true, '{', '}', true, '\0');
 
             if (tokens.size() == 0)
Index: /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.cc	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.cc	(revision 7276)
@@ -53,5 +53,5 @@
         this->numberOfEvaluatedParams_ = 0;
 
-        this->tokens_.split(command, " ", SubString::WhiteSpaces, false, '\\', true, '"', true, '(', ')', true, '\0');
+        this->tokens_.split(command, " ", SubString::WhiteSpaces, false, '\\', true, '"', true, '{', '}', true, '\0');
     }
 
Index: /code/branches/consolecommands3/src/libraries/core/command/Executor.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/Executor.cc	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/core/command/Executor.cc	(revision 7276)
@@ -59,5 +59,5 @@
     MultiType Executor::parse(const std::string& arguments, int* error, const std::string& delimiter, bool bPrintError) const
     {
-        return this->parse(SubString(arguments, delimiter, SubString::WhiteSpaces, false, '\\', true, '"', true, '(', ')', true, '\0'), error, delimiter, bPrintError);
+        return this->parse(SubString(arguments, delimiter, SubString::WhiteSpaces, false, '\\', true, '"', true, '{', '}', true, '\0'), error, delimiter, bPrintError);
     }
 
Index: /code/branches/consolecommands3/src/libraries/core/input/Button.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/input/Button.cc	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/core/input/Button.cc	(revision 7276)
@@ -117,5 +117,5 @@
         // separate the commands
         SubString commandStrings(bindingString_, "|", SubString::WhiteSpaces, false,
-            '\\', false, '"', false, '(', ')', false, '\0');
+            '\\', false, '"', false, '{', '}', false, '\0');
 
         for (unsigned int iCommand = 0; iCommand < commandStrings.size(); iCommand++)
@@ -124,5 +124,5 @@
             {
                 SubString tokens(commandStrings[iCommand], " ", SubString::WhiteSpaces, false,
-                    '\\', false, '"', false, '(', ')', false, '\0');
+                    '\\', false, '"', false, '{', '}', false, '\0');
 
                 KeybindMode::Value mode = KeybindMode::None;
Index: /code/branches/consolecommands3/src/libraries/util/Math.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/util/Math.cc	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/util/Math.cc	(revision 7276)
@@ -234,6 +234,6 @@
     bool ConverterFallback<std::string, orxonox::Vector2>::convert(orxonox::Vector2* output, const std::string& input)
     {
-        size_t opening_parenthesis, closing_parenthesis = input.find(')');
-        if ((opening_parenthesis = input.find('(')) == std::string::npos)
+        size_t opening_parenthesis, closing_parenthesis = input.find('}');
+        if ((opening_parenthesis = input.find('{')) == std::string::npos)
             opening_parenthesis = 0;
         else
@@ -257,6 +257,6 @@
     bool ConverterFallback<std::string, orxonox::Vector3>::convert(orxonox::Vector3* output, const std::string& input)
     {
-        size_t opening_parenthesis, closing_parenthesis = input.find(')');
-        if ((opening_parenthesis = input.find('(')) == std::string::npos)
+        size_t opening_parenthesis, closing_parenthesis = input.find('}');
+        if ((opening_parenthesis = input.find('{')) == std::string::npos)
             opening_parenthesis = 0;
         else
@@ -282,6 +282,6 @@
     bool ConverterFallback<std::string, orxonox::Vector4>::convert(orxonox::Vector4* output, const std::string& input)
     {
-        size_t opening_parenthesis, closing_parenthesis = input.find(')');
-        if ((opening_parenthesis = input.find('(')) == std::string::npos)
+        size_t opening_parenthesis, closing_parenthesis = input.find('}');
+        if ((opening_parenthesis = input.find('{')) == std::string::npos)
             opening_parenthesis = 0;
         else
@@ -309,6 +309,9 @@
     bool ConverterFallback<std::string, orxonox::Quaternion>::convert(orxonox::Quaternion* output, const std::string& input)
     {
-        size_t opening_parenthesis, closing_parenthesis = input.find(')');
-        if ((opening_parenthesis = input.find('(')) == std::string::npos) { opening_parenthesis = 0; } else { opening_parenthesis++; }
+        size_t opening_parenthesis, closing_parenthesis = input.find('}');
+        if ((opening_parenthesis = input.find('{')) == std::string::npos)
+            opening_parenthesis = 0;
+        else
+            opening_parenthesis++;
 
         SubString tokens(input.substr(opening_parenthesis, closing_parenthesis - opening_parenthesis), ",", SubString::WhiteSpaces, false, '\\', true, '"', true, '\0', '\0', true, '\0');
@@ -332,6 +335,9 @@
     bool ConverterFallback<std::string, orxonox::ColourValue>::convert(orxonox::ColourValue* output, const std::string& input)
     {
-        size_t opening_parenthesis, closing_parenthesis = input.find(')');
-        if ((opening_parenthesis = input.find('(')) == std::string::npos) { opening_parenthesis = 0; } else { opening_parenthesis++; }
+        size_t opening_parenthesis, closing_parenthesis = input.find('}');
+        if ((opening_parenthesis = input.find('{')) == std::string::npos)
+            opening_parenthesis = 0;
+        else
+            opening_parenthesis++;
 
         SubString tokens(input.substr(opening_parenthesis, closing_parenthesis - opening_parenthesis), ",", SubString::WhiteSpaces, false, '\\', true, '"', true, '\0', '\0', true, '\0');
Index: /code/branches/consolecommands3/src/libraries/util/SubString.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/util/SubString.h	(revision 7275)
+++ /code/branches/consolecommands3/src/libraries/util/SubString.h	(revision 7276)
@@ -81,5 +81,5 @@
             SL_SAFEESCAPE,        //!< In safe mode with the internal escape character, that escapes even the savemode character.
             SL_COMMENT,           //!< In Comment mode.
-            SL_PARENTHESES,       //!< Between parentheses (usually '(' and ')')
+            SL_PARENTHESES,       //!< Between parentheses (usually '{' and '}')
             SL_PARENTHESESESCAPE, //!< Between parentheses with the internal escape character, that escapes even the closing paranthesis character.
         } SPLIT_LINE_STATE;
@@ -92,5 +92,5 @@
                   const std::string& delimiters, const std::string& delimiterNeighbours = "", bool emptyEntries=false,
                   char escapeChar ='\\', bool removeEscapeChar = true, char safemode_char = '"', bool removeSafemodeChar = true,
-                  char openparenthesis_char = '(', char closeparenthesis_char = ')',  bool removeParenthesisChars = true, char comment_char = '\0');
+                  char openparenthesis_char = '{', char closeparenthesis_char = '}',  bool removeParenthesisChars = true, char comment_char = '\0');
         SubString(unsigned int argc, const char** argv);
         /** @brief create a Substring as a copy of another one. @param subString the SubString to copy. */
@@ -116,5 +116,5 @@
                            const std::string& delimiters, const std::string& delimiterNeighbours = "", bool emptyEntries = false,
                            char escapeChar ='\\', bool removeExcapeChar = true, char safemode_char = '"', bool removeSafemodeChar = true,
-                           char openparenthesis_char = '(', char closeparenthesis_char = ')',  bool removeParenthesisChars = true, char comment_char = '\0');
+                           char openparenthesis_char = '{', char closeparenthesis_char = '}',  bool removeParenthesisChars = true, char comment_char = '\0');
         std::string join(const std::string& delimiter = " ") const;
         ////////////////////////////////////////
@@ -155,6 +155,6 @@
                                           char safemode_char = '"',
                                           bool removeSafemodeChar = true,
-                                          char openparenthesis_char = '(',
-                                          char closeparenthesis_char = ')',
+                                          char openparenthesis_char = '{',
+                                          char closeparenthesis_char = '}',
                                           bool removeParenthesisChars = true,
                                           char comment_char = '\0',