Index: branches/shared_lib/src/Makefile.am
===================================================================
--- branches/shared_lib/src/Makefile.am	(revision 7280)
+++ branches/shared_lib/src/Makefile.am	(revision 7281)
@@ -5,5 +5,7 @@
 
 LIB_PREFIX=lib
-include lib/BuildLibs.am
+include $(LIB_PREFIX)/BuildLibs.am
+WORLDENTITY_PREFIX=world_entities
+include $(WORLDENTITY_PREFIX)/world_entity.am
 
 #"-O3 -pedantic -fPIC -ffast-math -I/usr/X11R6/include"
@@ -19,5 +21,7 @@
 		util/libORXutils.a \
 		$(LIBLTDL) \
-		$(libORXlibs_a_LIBRARIES_)
+		$(libORXlibs_a_LIBRARIES_) \
+		$(WorldEntities_LIBRARIES_)
+
 
 orxonox_LDADD = \
@@ -25,4 +29,5 @@
 		util/libORXutils.a \
 		$(libORXlibs_a_LIBRARIES_) \
+		$(WorldEntities_LIBRARIES_) \
 		@LIBLTDL@ \
 		@LIBADD_DL@ \
Index: branches/shared_lib/src/lib/shell/shell_command.h
===================================================================
--- branches/shared_lib/src/lib/shell/shell_command.h	(revision 7280)
+++ branches/shared_lib/src/lib/shell/shell_command.h	(revision 7281)
@@ -15,6 +15,6 @@
 
 
-
 // FORWARD DECLARATION
+class ShellCommand;
 class ShellCommandClass;
 class ShellCommandAlias;
@@ -61,5 +61,7 @@
   friend class ShellCommandClass;
   public:
-    static bool execute (const std::string& executionString);
+    ShellCommand(const std::string& commandName, const std::string& className, const Executor& executor);
+    ~ShellCommand();
+
 
     ShellCommand* describe(const std::string& description);
@@ -68,4 +70,6 @@
                                 const MultiType& value2 = MT_NULL, const MultiType& value3 = MT_NULL,
                                 const MultiType& value4 = MT_NULL);
+
+    static bool execute (const std::string& executionString);
 
     static ShellCommand* registerCommand(const std::string& commandName, const std::string& className, const Executor& executor);
@@ -76,7 +80,4 @@
 
   protected:
-    ShellCommand(const std::string& commandName, const std::string& className, const Executor& executor);
-    ~ShellCommand();
-
     static bool isRegistered(const std::string& commandName, const std::string& className);
     static const char* paramToString(long parameter);
Index: branches/shared_lib/src/orxonox.cc
===================================================================
--- branches/shared_lib/src/orxonox.cc	(revision 7280)
+++ branches/shared_lib/src/orxonox.cc	(revision 7281)
@@ -349,15 +349,14 @@
   /// FIXME make this more modular (search for himself for all the libraries
   PRINTF(0)("We are searching for plugins in %s\n", DynamicLoader::getSearchDir());
-  DynamicLoader::loadDyLib("libORXweapons.la");
-  DynamicLoader::loadDyLib("libORXprojectiles.la");
-  DynamicLoader::loadDyLib("libORXpower_ups.la");
-
-  DynamicLoader::loadDyLib("libORXenvironmentals.la");
-
-  DynamicLoader::loadDyLib("libORXmisc_entities.la");
-
-  DynamicLoader::loadDyLib("libORXplayables.la");
-  DynamicLoader::loadDyLib("libORXnpcs.la");
-  printf("%s\n", DynamicLoader::getSearchDir());
+//   DynamicLoader::loadDyLib("libORXweapons.la");
+//   DynamicLoader::loadDyLib("libORXprojectiles.la");
+//   DynamicLoader::loadDyLib("libORXpower_ups.la");
+//
+//   DynamicLoader::loadDyLib("libORXenvironmentals.la");
+//
+//   DynamicLoader::loadDyLib("libORXmisc_entities.la");
+//
+//   DynamicLoader::loadDyLib("libORXplayables.la");
+//   DynamicLoader::loadDyLib("libORXnpcs.la");
 
   // start the collision detection engine
Index: branches/shared_lib/src/world_entities/Makefile.am
===================================================================
--- branches/shared_lib/src/world_entities/Makefile.am	(revision 7280)
+++ branches/shared_lib/src/world_entities/Makefile.am	(revision 7281)
@@ -41,5 +41,5 @@
 #		npcs/npc.cc
 
-AM_LDFLAGS = -module -no-undefined
+AM_LDFLAGS = -no-undefined
 
 pkglib_LTLIBRARIES = \
@@ -109,4 +109,7 @@
 		effects/lightning_bolt.cc
 
+
+EXTRA_DIST = \
+		world_entity.am
 
 noinst_HEADERS  = \
Index: branches/shared_lib/src/world_entities/WorldEntities.am
===================================================================
--- branches/shared_lib/src/world_entities/WorldEntities.am	(revision 7280)
+++ 	(revision )
@@ -1,51 +1,0 @@
-## THE SUBCLASSES. THESE MUST BE DYNAMICALLY LINKED OR COMPILED IN DIRECTLY
-WorldEntities_SOURCES_ = \
-		world_entities/npcs/npc_test1.cc \
-		world_entities/npcs/npc_test.cc \
-		\
-		world_entities/environment.cc \
-		world_entities/skysphere.cc \
-		world_entities/skybox.cc \
-		world_entities/terrain.cc \
-		world_entities/satellite.cc \
-		world_entities/movie_entity.cc \
-		world_entities/recorder.cc \
-		world_entities/character_attributes.cc \
-		world_entities/test_entity.cc \
-		world_entities/planet.cc \
-		\
-		world_entities/weapons/test_gun.cc \
-		world_entities/weapons/turret.cc \
-		world_entities/weapons/aiming_turret.cc \
-		world_entities/weapons/targeting_turret.cc \
-		world_entities/weapons/cannon.cc \
-		world_entities/weapons/hyperblaster.cc \
-		world_entities/weapons/aim.cc \
-		\
-		world_entities/projectiles/bomb.cc \
-		world_entities/projectiles/laser.cc \
-		world_entities/projectiles/test_bullet.cc \
-		world_entities/projectiles/rocket.cc \
-		world_entities/projectiles/guided_missile.cc \
-		world_entities/projectiles/hyperblast.cc \
-		\
-		world_entities/power_ups/turret_power_up.cc \
-		world_entities/power_ups/laser_power_up.cc \
-		\
-		world_entities/space_ships/space_ship.cc \
-		world_entities/space_ships/helicopter.cc \
-		world_entities/space_ships/hover.cc \
-		world_entities/space_ships/turbine_hover.cc \
-		world_entities/creatures/md2_creature.cc \
-		\
-		\
-		world_entities/environments/water.cc \
-		world_entities/environments/model_entity.cc \
-		world_entities/environments/building.cc \
-		\
-		world_entities/elements/image_entity.cc \
-		world_entities/elements/text_element.cc \
-		\
-		world_entities/effects/lightning_bolt.cc
-
-
Index: branches/shared_lib/src/world_entities/world_entity.am
===================================================================
--- branches/shared_lib/src/world_entities/world_entity.am	(revision 7281)
+++ branches/shared_lib/src/world_entities/world_entity.am	(revision 7281)
@@ -0,0 +1,12 @@
+## THE SUBCLASSES. THESE MUST BE DYNAMICALLY LINKED OR COMPILED IN DIRECTLY
+WorldEntities_LIBRARIES_ = \
+		$(WORLDENTITY_PREFIX)/libORXplayables.la \
+		$(WORLDENTITY_PREFIX)/libORXweapons.la \
+		$(WORLDENTITY_PREFIX)/libORXprojectiles.la \
+		$(WORLDENTITY_PREFIX)/libORXpower_ups.la \
+		\
+		$(WORLDENTITY_PREFIX)/libORXenvironmentals.la \
+		\
+		$(WORLDENTITY_PREFIX)/libORXnpcs.la \
+		\
+		$(WORLDENTITY_PREFIX)/libORXmisc_entities.la