Index: /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.h	(revision 7281)
+++ /code/branches/consolecommands3/src/libraries/core/command/CommandEvaluation.h	(revision 7282)
@@ -61,5 +61,5 @@
                 { return (this->execCommand_ != 0); }
 
-            inline ConsoleCommand* getConsoleCommand() const
+            inline const ConsoleCommand* getConsoleCommand() const
                 { return this->execCommand_; }
 
@@ -90,6 +90,6 @@
             static std::string getCommonBegin(const ArgumentCompletionList& list);
 
-            ConsoleCommand* execCommand_;
-            ConsoleCommand* hintCommand_;
+            const ConsoleCommand* execCommand_;
+            const ConsoleCommand* hintCommand_;
             SubString tokens_;
             std::string string_;
Index: /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.cc
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.cc	(revision 7281)
+++ /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.cc	(revision 7282)
@@ -415,5 +415,5 @@
     }
 
-    /* static */ ConsoleCommand* ConsoleCommand::getCommand(const std::string& group, const std::string& name, bool bPrintError)
+    /* static */ const ConsoleCommand* ConsoleCommand::getCommand(const std::string& group, const std::string& name, bool bPrintError)
     {
         std::map<std::string, std::map<std::string, ConsoleCommand*> >::const_iterator it_group = ConsoleCommand::getCommandMap().find(group);
@@ -436,5 +436,5 @@
     }
 
-    /* static */ ConsoleCommand* ConsoleCommand::getCommandLC(const std::string& group, const std::string& name, bool bPrintError)
+    /* static */ const ConsoleCommand* ConsoleCommand::getCommandLC(const std::string& group, const std::string& name, bool bPrintError)
     {
         std::string groupLC = getLowercase(group);
Index: /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.h	(revision 7281)
+++ /code/branches/consolecommands3/src/libraries/core/command/ConsoleCommand.h	(revision 7282)
@@ -336,11 +336,11 @@
                 { return ConsoleCommand::getCommandMapLC(); }
 
-            static inline ConsoleCommand* getCommand(const std::string& name, bool bPrintError = false)
+            static inline const ConsoleCommand* getCommand(const std::string& name, bool bPrintError = false)
                 { return ConsoleCommand::getCommand("", name, bPrintError); }
-            static inline ConsoleCommand* getCommandLC(const std::string& name, bool bPrintError = false)
+            static inline const ConsoleCommand* getCommandLC(const std::string& name, bool bPrintError = false)
                 { return ConsoleCommand::getCommandLC("", name, bPrintError); }
 
-            static ConsoleCommand* getCommand(const std::string& group, const std::string& name, bool bPrintError = false);
-            static ConsoleCommand* getCommandLC(const std::string& group, const std::string& name, bool bPrintError = false);
+            static const ConsoleCommand* getCommand(const std::string& group, const std::string& name, bool bPrintError = false);
+            static const ConsoleCommand* getCommandLC(const std::string& group, const std::string& name, bool bPrintError = false);
 
             static void destroyAll();
Index: /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.h
===================================================================
--- /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.h	(revision 7281)
+++ /code/branches/consolecommands3/src/libraries/core/command/TclThreadManager.h	(revision 7282)
@@ -38,5 +38,4 @@
 
 #include "util/Singleton.h"
-#include "core/OrxonoxClass.h"
 
 struct Tcl_Interp;