Index: trunk/src/lib/sound/ogg_player.cc
===================================================================
--- trunk/src/lib/sound/ogg_player.cc	(revision 7289)
+++ trunk/src/lib/sound/ogg_player.cc	(revision 7290)
@@ -49,5 +49,5 @@
 OggPlayer::~OggPlayer()
 {
-  //this->release();
+  this->release();
 }
 
Index: trunk/src/lib/sound/sound_buffer.cc
===================================================================
--- trunk/src/lib/sound/sound_buffer.cc	(revision 7289)
+++ trunk/src/lib/sound/sound_buffer.cc	(revision 7290)
@@ -47,4 +47,5 @@
   //  SoundEngine::getInstance()->removeBuffer(this);
   alDeleteBuffers(1, &this->bufferID);
+  SoundEngine::checkError("SoundBuffer: Delete Buffer", __LINE__);
 }
 
Index: trunk/src/lib/sound/sound_engine.cc
===================================================================
--- trunk/src/lib/sound/sound_engine.cc	(revision 7289)
+++ trunk/src/lib/sound/sound_engine.cc	(revision 7290)
@@ -70,5 +70,5 @@
   {
     while (this->sourceList->size() > 0)
-      delete dynamic_cast<SoundSource*>(this->sourceList->front());
+      delete static_cast<SoundSource*>(this->sourceList->front());
   }
 
@@ -76,4 +76,5 @@
   {
     alDeleteSources(1, &this->ALSources.top());
+    SoundEngine::checkError("Deleting Source", __LINE__);
     this->ALSources.pop();
   }
@@ -83,5 +84,5 @@
   {
     while(this->bufferList->size() > 0)
-      ResourceManager::getInstance()->unload(dynamic_cast<SoundBuffer*>(this->bufferList->front()));
+      ResourceManager::getInstance()->unload(static_cast<SoundBuffer*>(this->bufferList->front()));
   }
 
@@ -146,5 +147,4 @@
     this->ALSources.pop();
   }
-
 }
 
@@ -155,5 +155,4 @@
 void SoundEngine::update()
 {
-
   // updating the Listeners Position
   if (likely(this->listener != NULL))
@@ -199,5 +198,4 @@
                        source->getNode()->getVelocity().z);
           }
-
         }
         else
@@ -208,4 +206,5 @@
     }
   }
+  SoundEngine::checkError("SoundEngine::update()", __LINE__);
 }
 
@@ -309,7 +308,7 @@
   // #endif
 
-  printf ("===== SOURCECOUNT: %d\n", this->maxSourceCount);
   this->setDopplerValues(SOUND_DOPPLER_FACTOR, SOUND_DOPPLER_VELOCITY);
   this->allocateSources(this->maxSourceCount);
+  this->checkError("Allocating Sources", __LINE__);
 }
 
@@ -422,3 +421,2 @@
   };
 }
-
Index: trunk/src/lib/sound/sound_source.cc
===================================================================
--- trunk/src/lib/sound/sound_source.cc	(revision 7289)
+++ trunk/src/lib/sound/sound_source.cc	(revision 7290)
@@ -57,4 +57,6 @@
     SoundEngine::getInstance()->popALSource(this->sourceID);
   alSourcePlay(this->sourceID);
+  if (DEBUG >= 3)
+    SoundEngine::checkError("Play Source", __LINE__);
   this->bPlay = true;
 }
@@ -77,4 +79,7 @@
     alSourcei (this->sourceID, AL_BUFFER, this->buffer->getID());
   this->bPlay = true;
+
+  if (DEBUG >= 3)
+    SoundEngine::checkError("Play Source", __LINE__);
 }
 
@@ -95,4 +100,6 @@
 {
   alSourcePause(this->sourceID);
+  if (DEBUG >= 3)
+    SoundEngine::checkError("Pause Source", __LINE__);
 }
 
@@ -103,4 +110,7 @@
 {
   alSourceRewind(this->sourceID);
+
+  if (DEBUG >= 3)
+    SoundEngine::checkError("Rewind Source", __LINE__);
 }
 
@@ -114,4 +124,7 @@
 {
   alSourcef(this->sourceID, AL_ROLLOFF_FACTOR, rolloffFactor);
+
+  if (DEBUG >= 3)
+    SoundEngine::checkError("Set Source Rolloff-factor", __LINE__);
 }
 
Index: trunk/src/story_entities/game_world.cc
===================================================================
--- trunk/src/story_entities/game_world.cc	(revision 7289)
+++ trunk/src/story_entities/game_world.cc	(revision 7290)
@@ -136,5 +136,5 @@
 int GameWorld::createAudioThread(void* gameWorld)
 {
-  GameWorld* gw = (GameWorld*)gameWorld;
+/*  GameWorld* gw = (GameWorld*)gameWorld;
   printf("STARTIG AUDIO THREAD\n");
   if(gw->dataTank && gw->dataTank->music != NULL)
@@ -145,6 +145,6 @@
     if(gw->dataTank && gw->dataTank->music != NULL)
       gw->dataTank->music->update();
-    SDL_Delay(5);
-  }
+    SDL_Delay(1);
+  }*/
   printf("End the AudioThread\n");
 }