Index: /code/branches/doc/src/libraries/core/XMLPort.h
===================================================================
--- /code/branches/doc/src/libraries/core/XMLPort.h	(revision 7290)
+++ /code/branches/doc/src/libraries/core/XMLPort.h	(revision 7291)
@@ -153,5 +153,5 @@
     With this macro, you can simply use them instead of writing your own functions.
 
-    @example
+    Example:
     Your class is called SpaceShip and this class has an object (myPilot_) of class Pilot. Pilot has a name
     and two functions, setName(name) and getName(). Now you want an attribute "pilotname" in your
@@ -231,5 +231,5 @@
         }
 
-    @example
+    Example:
     Possible usage of the macro:
     > XMLPortObject(SpaceShip, Weapon, "weapons", addWeapon, getWeapon, xmlelement, mode, false, true);
Index: /code/branches/doc/src/libraries/util/Debug.h
===================================================================
--- /code/branches/doc/src/libraries/util/Debug.h	(revision 7290)
+++ /code/branches/doc/src/libraries/util/Debug.h	(revision 7291)
@@ -52,5 +52,6 @@
      6: Crazy debug information
 
-@example
+    Example:
+    @code
     COUT(0) << "Very important output" << std::endl;
     COUT(1) << "Error: Something went wrong!" << std::endl;
@@ -58,4 +59,5 @@
     COUT(3) << "Info: It's Monday" << std::endl;
     COUT(4) << "Debug: x is 1.23456" << std::endl;
+    @endcode
 */
 
@@ -96,6 +98,9 @@
     where (a > b ? 0 : ) stands for COUT(x). This should explain how
     this macro magic can possibly even work ;)
-@example
+
+    Example:
+    @code
     COUT(3) << "Some info" << std::endl;
+    @endcode
 @note
     The ? : operator requires both possible results to have the type of
Index: /code/branches/doc/src/libraries/util/Math.cc
===================================================================
--- /code/branches/doc/src/libraries/util/Math.cc	(revision 7290)
+++ /code/branches/doc/src/libraries/util/Math.cc	(revision 7291)
@@ -93,5 +93,5 @@
         @return The angle
 
-        @example
+        Examples:
         If the other object is exactly in front of me, the function returns 0.
         If the other object is exactly behind me, the function returns pi.
@@ -116,5 +116,5 @@
         @return The viewing direction
 
-        @example
+        Examples:
         If the other object is exactly in front of me, the function returns Vector2(0, 0).
         If the other object is exactly at my left, the function returns Vector2(-1, 0).
@@ -156,5 +156,5 @@
         @return The viewing direction
 
-        @example
+        Examples:
         If the other object is exactly in front of me, the function returns Vector2(0, 0).
         If the other object is exactly at my left, the function returns Vector2(-0.5, 0).
Index: /code/branches/doc/src/libraries/util/MultiType.h
===================================================================
--- /code/branches/doc/src/libraries/util/MultiType.h	(revision 7290)
+++ /code/branches/doc/src/libraries/util/MultiType.h	(revision 7291)
@@ -52,5 +52,6 @@
      - setValue<T>(value) assigns a new value and changes the type to T.
 
-    @example
+    Examples:
+    @code
     MultiType a = 10;;         // a has now the type int and the value 10
     a.setValue("3.14");        // a has still the type int and "3.14" gets converted, therefore the value is now 3
@@ -58,4 +59,5 @@
     a.convert<bool>();         // converts 3.14 to bool, which is true
     a = false;                 // assigns false, this is equivalent to a.setValue(false)
+    @endcode
 
     @note
Index: /code/branches/doc/src/libraries/util/SubString.h
===================================================================
--- /code/branches/doc/src/libraries/util/SubString.h	(revision 7290)
+++ /code/branches/doc/src/libraries/util/SubString.h	(revision 7291)
@@ -47,8 +47,8 @@
  * but also removing leading and trailing spaces around the comma.
  *
- * @example
+ * Example:
  * Split the String std::string st = "1345, The new empire   , is , orxonox"
  * is splitted with:
- * SubString(st, ',', " \n\t")
+ * @code SubString(st, ',', " \n\t") @endcode
  * into
  * "1345", "The new empire", "is", "orxonox"